#include "gc/link.h"

namespace gc {

Link::Link() : prev(this), next(this) {}

Link::~Link() { detach(); }

void Link::detach() {
	prev->next = next;
	next->prev = prev;
	prev = next = this;
}

void Link::attach(Link *l) {
	detach();
	prev = l->prev;
	prev->next = this;
	next = l;
	l->prev = this;
}

int Link::size() const {
	int n = 0;
	for (Link *p = next; p != this; p = p->next) {
		n++;
	}
	return n;
}

};
